题目描述
给定一个不重复整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
题解
思路 1:暴力枚举
枚举每一种组合(j>i),判断nums[i] + nums[j] = target
// OC
+ (NSArray *)twoSum1:(NSArray *)nums target:(int)target {
NSMutableArray *resArray = [[NSMutableArray alloc] init];
for (int i=0; i<nums.count; i++) {
for (int j=i+1; j<nums.count; j++) {
if ([nums[i] intValue] + [nums[j] intValue] == target) {
[resArray addObject:@[[NSNumber numberWithInt:i],[NSNumber numberWithInt:j]]];
}
}
}
return [resArray firstObject];
}
// Swift
static public func twoSum1(_ nums: [Int], _ target: Int) -> [Int] {
var res = [[Int]]()
for i in 0..<nums.count {
for j in (i+1)..<nums.count {
if nums[i] + nums[j] == target {
res.append([i,j])
}
}
}
return res.first ?? [Int]()
}
思路2: 哈希表
对于每一个 x,我们首先查询哈希表中是否存在 target - x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配
// OC
+ (NSArray *)twoSum2:(NSArray *)nums target:(int)target {
NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
NSMutableArray *resArray = [[NSMutableArray alloc] init];
for (int i=0; i<nums.count; i++) {
NSString *resKey = [NSString stringWithFormat:@"%d",target - [nums[i] intValue]];
NSString *tempKey = [NSString stringWithFormat:@"%d",[nums[i] intValue]];
if (dict[resKey] != nil) {
[resArray addObject:@[[NSNumber numberWithInt:i],dict[resKey]]];
}
dict[tempKey] = [NSNumber numberWithInt:i];
}
return [resArray firstObject];
}
// Swift
static public func twoSum2(_ nums: [Int], _ target: Int) -> [Int] {
var hashtable = [Int:Int]()
var res = [[Int]]()
for i in 0..<nums.count {
if hashtable[target-nums[i]] != nil {
res.append([i,hashtable[target-nums[i]]!])
}
hashtable[nums[i]] = i
}
return res.first ?? [Int]()
}
参考:https://leetcode-cn.com/leetbook/read/top-interview-questions-easy/x2jrse/